'Sun  Apr 23, 1989   11:13:32 pm
'*****************************************************************************
'This routine reads and sets the BREAK setting, which enables Ctrl-Break exit
'from within a program. 0 = BREAK OFF  1 = BREAK ON
'*****************************************************************************

TYPE RegType
     ax    AS INTEGER
     bx    AS INTEGER
     cx    AS INTEGER
     dx    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
END TYPE

DIM SHARED inregs AS RegType, outregs AS RegType

DECLARE FUNCTION break ()
DECLARE SUB setbreak (value)

setbreak 0
PRINT break

FUNCTION break
     inregs.ax = &H3300
     CALL interrupt(&H21, inregs, outregs)
     dh = FIX(outregs.dx / 256)
     dl = outregs.dx - (dh * 256)
     break = dl
END FUNCTION

SUB setbreak (value)
     inregs.ax = &H3300 + &H1: inregs.dx = value
     CALL interrupt(&H21, inregs, outregs)
END SUB

